Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Code gnr par le Concepteur Windows Form "

    Public Sub New()
        MyBase.New()

        'Cet appel est requis par le Concepteur Windows Form.
        InitializeComponent()

        'Ajoutez une initialisation quelconque aprs l'appel InitializeComponent()

    End Sub

    'La mthode substitue Dispose du formulaire pour nettoyer la liste des composants.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Requis par le Concepteur Windows Form
    Private components As System.ComponentModel.IContainer

    'REMARQUE: la procdure suivante est requise par le Concepteur Windows Form
    'Elle peut tre modifie en utilisant le Concepteur Windows Form.  
    'Ne la modifiez pas en utilisant l'diteur de code.
    Friend WithEvents ImageList1 As System.Windows.Forms.ImageList
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
        Me.ImageList1 = New System.Windows.Forms.ImageList(Me.components)
        '
        'ImageList1
        '
        Me.ImageList1.ImageSize = New System.Drawing.Size(32, 32)
        Me.ImageList1.ImageStream = CType(resources.GetObject("ImageList1.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ImageList1.TransparentColor = System.Drawing.Color.Transparent
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(317, 318)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "Form1"
        Me.Text = "Just a pawn in their game"

    End Sub

#End Region

    Public numdep, couleur As Integer


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' Cration des cases de l'chiquier. Pas de grosses difficults
        Dim i As Integer
        For i = 0 To 63
            ' il s'agit de PictureBox
            Dim Cas As New PictureBox
            ' on leur donne comme nom leur numro de cration
            Cas.Name = i
            Cas.Text = ""
            'on les positionne au bon endroit
            Cas.Size = New Size(40, 40)
            Dim ligne As Integer = Int(i / 8)
            Dim col As Integer = i - ligne * 8
            Cas.Top = ligne * 40
            Cas.Left = col * 40
            Cas.BorderStyle = BorderStyle.None
            Cas.SizeMode = PictureBoxSizeMode.CenterImage
            ' on n'oublie pas de les ajouter  la collection des contrles
            Controls.Add(Cas)
            ' on gre le coloriage en noir et blanc, un peu pnible
            If Int(ligne / 2) = ligne / 2 Xor Int(col / 2) = col / 2 Then
                Cas.BackColor = Color.White
            Else
                Cas.BackColor = Color.Gray
            End If
            ' on dessine les deux ranges de pions
            ' le tag mmorise l'tat de la case
            If ligne = 6 Then
                Cas.Image = ImageList1.Images(0)
                Cas.Tag = 0
            ElseIf ligne = 1 Then
                Cas.Image = ImageList1.Images(1)
                Cas.Tag = 1
            Else
                Cas.Tag = 2
            End If
            Cas.AllowDrop = True
            ' Et on branche chaque case sur les vnements adquats
            AddHandler Cas.MouseDown, AddressOf DbutDD
            AddHandler Cas.DragEnter, AddressOf MilieuDD
            AddHandler Cas.DragDrop, AddressOf FinDD
            AddHandler Cas.GiveFeedback, AddressOf Fidbac
        Next i
    End Sub

    Private Sub DbutDD(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        ' Cette procdure gre le dbut du Drag & Drop
        ' Com d'habitude, on recherche par une boucle la case
        ' qui a provoqu l'vnement
        Dim toto As Object
        For Each toto In Controls
            If TypeOf toto Is PictureBox Then
                If toto.name = sender.name Then
                    ' on note la case de dpart dans une variable publique
                    numdep = CInt(toto.name)
                    ' idem pour la couleur du pion
                    couleur = sender.tag
                    Dim z As Image = toto.image
                    ' on efface l'image
                    toto.image = Nothing
                    ' on dclenche le Drag & Drop
                    toto.dodragdrop(z, DragDropEffects.All)
                End If
            End If
        Next toto
    End Sub

    Private Sub Fidbac(ByVal sender As Object, ByVal e As System.Windows.Forms.GiveFeedbackEventArgs)
        ' Cette procdure change le curseur pour mettre  la place
        ' l'image du pion victime du Drag
        e.UseDefaultCursors = False
        If couleur = 0 Then
            Cursor.Current = New Cursor("blanc.ico")
        Else
            Cursor.Current = New Cursor("noir.ico")
        End If
    End Sub

    Private Sub MilieuDD(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs)
        ' Cette procdure se contente du service minimum : RAS
        e.Effect = DragDropEffects.Move
    End Sub

    Private Sub FinDD(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs)
        ' Et l, on gre l'atterrissage.
        Dim toto As Object
        ' On a cr une fonction boolenne qui indique si le mouvement
        ' tait lgitime ou non
        If Autorise(sender.name, sender.tag) Then
            ' cas o le mouvement est autoris
            For Each toto In Controls
                If TypeOf toto Is PictureBox Then
                    ' Dans la case qui reoit le pion, on met  jour l'image et le tag
                    If toto.name = sender.name Then
                        toto.image = e.Data.GetData(DataFormats.Bitmap)
                        toto.tag = couleur
                        ' dans la case d'o partait le pion, on met  jour le tag
                    ElseIf toto.name = numdep Then
                        toto.tag = 2
                    End If
                End If
            Next toto
        Else
            ' cas o le dplacement est illgitime
            For Each toto In Controls
                If TypeOf toto Is PictureBox Then
                    If toto.name = numdep Then
                        ' on remet l'image dans la case de dpart
                        toto.image = ImageList1.Images(couleur)
                    End If
                End If
            Next toto
        End If
    End Sub

    Private Function Autorise(ByVal numarr As Integer, ByVal coularr As Integer)
        ' Fonction qui renvoie une valeur boolenne
        ' indiquant si le mouvement est autoris ou non
        ' les diffrents cas sont plus laborieux que difficiles
        ' il faut tenir compte du mouvement, 
        ' de la couleur du pion de dpart, 
        'et de l'tat de la case d'arrive.
        Dim cas1, cas2, cas3, cas4, cas5, cas6 As Boolean
        cas1 = numarr - numdep = 8 And coularr = 2 And couleur = 1
        cas2 = numarr - numdep = -8 And coularr = 2 And couleur = 0
        cas3 = numarr - numdep = 16 And coularr = 2 And couleur = 1 And numdep >= 8 And numdep <= 15
        cas4 = numarr - numdep = -16 And coularr = 2 And couleur = 0 And numdep >= 48 And numdep <= 55
        cas5 = (numarr - numdep = 7 Or numarr - numdep = 9) And coularr = 0 And couleur = 1
        cas6 = (numarr - numdep = -7 Or numarr - numdep = -9) And coularr = 1 And couleur = 0
        Me.Text = cas1 Or cas2 Or cas3 Or cas4 Or cas5 Or cas6
        If cas1 Or cas2 Or cas3 Or cas4 Or cas5 Or cas6 Then
            Autorise = True
        Else
            Autorise = False
        End If
    End Function
End Class
